/*
 * Copyright (C) 2015 by
 *   MetraLabs GmbH (MLAB), GERMANY
 * and
 *   Neuroinformatics and Cognitive Robotics Labs (NICR) at TU Ilmenau, GERMANY
 * All rights reserved.
 *
 * Contact: info@mira-project.org
 *
 * Commercial Usage:
 *   Licensees holding valid commercial licenses may use this file in
 *   accordance with the commercial license agreement provided with the
 *   software or, alternatively, in accordance with the terms contained in
 *   a written agreement between you and MLAB or NICR.
 *
 * GNU General Public License Usage:
 *   Alternatively, this file may be used under the terms of the GNU
 *   General Public License version 3.0 as published by the Free Software
 *   Foundation and appearing in the file LICENSE.GPL3 included in the
 *   packaging of this file. Please review the following information to
 *   ensure the GNU General Public License version 3.0 requirements will be
 *   met: http://www.gnu.org/copyleft/gpl.html.
 *   Alternatively you may (at your option) use any later version of the GNU
 *   General Public License if such license has been publicly approved by
 *   MLAB and NICR (or its successors, if any).
 *
 * IN NO EVENT SHALL "MLAB" OR "NICR" BE LIABLE TO ANY PARTY FOR DIRECT,
 * INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
 * THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF "MLAB" OR
 * "NICR" HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * "MLAB" AND "NICR" SPECIFICALLY DISCLAIM ANY WARRANTIES, INCLUDING,
 * BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS FOR A PARTICULAR PURPOSE. THE SOFTWARE PROVIDED HEREUNDER IS
 * ON AN "AS IS" BASIS, AND "MLAB" AND "NICR" HAVE NO OBLIGATION TO
 * PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS OR MODIFICATIONS.
 */

/**
 * @file $NAME$Visualization3D.C
 *    $DESCRIPTION$
 *
 * @author $AUTHOR$
 * @date   $DATE$
 */

#include <visualization/Visualization3DBasic.h>

#include <$NAME$.h>

using namespace mira;

$NAMESPACE_BEGIN$

///////////////////////////////////////////////////////////////////////////////

/**
 * $DESCRIPTION$
 */
class $NAME$Visualization3D : public Visualization3DBasic<$NAME$>
{
MIRA_META_OBJECT($NAME$Visualization3D, // TODO: add correct name, category and description
			("Name", "$NAME$Visualization")
			("Category", "General")
			("Description", "Visualization of $NAME$"))

	typedef $NAME$ Type;
	typedef Visualization3DBasic<Type> Base;

public:

	$NAME$Visualization3D();

	template<typename Reflector>
	void reflect(Reflector& r)
	{
		MIRA_REFLECT_BASE(r, Base);

		// TODO: reflect all parameters (members and properties) that specify the persistent state of the unit
		//r.property("Param1", mParam1, "First parameter of this unit with default value", 123.4f);
		//r.member("Param2", mParam2, setter(&$NAME$Visualization3D::setParam2,this), "Second parameter with setter");
	}


	virtual void setupScene(Ogre::SceneManager* mgr, Ogre::SceneNode* node);

protected:

	virtual void dataChanged(ChannelRead<Type> data);

};

///////////////////////////////////////////////////////////////////////////////

$NAME$Visualization3D::$NAME$Visualization3D() : Base("$NAME$") // TODO: << enter the name that should be shown in the visualization control
{
	// contructor
}

void $NAME$Visualization3D::setupScene(Ogre::SceneManager* mgr, Ogre::SceneNode* node)
{
	// TODO: create your visual objects using Ogre
	//mPoint = new MeshObject("Sphere.mesh", mgr, node);
}

void $NAME$Visualization3D::dataChanged(ChannelRead<Type> data)
{
	// TODO: is called whenever the data has changed
}

///////////////////////////////////////////////////////////////////////////////

$NAMESPACE_END$

MIRA_CLASS_SERIALIZATION($NAMESPACE$::$NAME$Visualization3D, mira::Visualization3D);
